% Example_12_3
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
% Orthogonal filter bank
clear all, close all
N = 18;
[h0,h1,g0,g1] = firpr2chfb(N-1,0.4); 
n=0:N-1;
figure (1)
subplot(4,1,1)
stem(n,h0)
ylabel('h_0[n]')
subplot(4,1,2)
stem(n,h1)
ylabel('h_1[n]')
subplot(4,1,3)
stem(n,g0)
ylabel('g_0[n]')
subplot(4,1,4)
stem(n,g1)
ylabel('g_1[n]')
xlabel('n')
[H0,f]=freqz(h0,1,1024,2);
[H1,f]=freqz(h1,1,1024,2);
figure (2)
subplot(4,1,1:3)
plot(f,20*log10(abs(H0)),f,20*log10(abs(H1)),'b','LineWidth',1); grid
%title('Two-channel filter bank')
xlabel('\omega/\pi'), ylabel('Gain, dB')
axis([0,1,-60,2])
figure(2)
subplot(4,1,4)
% stem(0:2*(N-1),conv((-1).^n.*h1,h0)-conv((-1).^n.*h0,h1))
t = (conv(h0,g0)+conv(h1,g1))/2
stem(0:2*(N-1),t)
xlabel('n'), ylabel('t[n]')
axis([0,2*(N-1),-0.2,1.1])