% Example_12_4
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
clear all, close all
wname = 'db5'; 
% Compute the four filters associated with wavelet name given 
% by the input string wname. 
[Lo_D,Hi_D,Lo_R,Hi_R] = wfilters(wname); 
N=length(Lo_D)
figure (1)
subplot(221); stem(0:N-1,Lo_D); 
title('Decomposition lowpass filter'); 
%axis([0,N-1,-0.5,1])
subplot(222); stem(0:N-1,Hi_D); 
title('Decomposition highpass filter'); 
%axis([0,N-1,-1,1])
subplot(223); stem(0:N-1,Lo_R); xlabel('n')
title('Reconstruction lowpass filter'); 
subplot(224); stem(0:N-1,Hi_R); xlabel('n')
title('Reconstruction highpass filter'); 
%xlabel('The four filters for db5')
% Editing some graphical properties,
% the following figure is generated.

figure (2)
subplot(2,2,1)
zplane(Lo_D,1)
title('Decomposition lowpass filter'); 
subplot(2,2,2)
zplane(Hi_D,1)
title('Decomposition highpass filter'); 
subplot(2,2,3)
zplane(Lo_R,1)
title('Reconstruction lowpass filter'); 
subplot(2,2,4)
zplane(Hi_R,1)
title('Reconstruction highpass filter'); 
[HLo_D,f]=freqz(Lo_D,1,512,2);

figure (3)
subplot(7,1,1:4)
plot(f,abs(HLo_D))
xlabel('Normalized frequency \omega/\pi'), ylabel ('Magnitude')
hold on
[HHi_D,f]=freqz(Hi_D,1,512,2);
subplot(7,1,1:4)
plot(f,abs(HHi_D)),grid

figure (4)
plot(f,(abs(HLo_D)).^2+(abs(HHi_D)).^2)
N=length(Lo_D)
n=0:N-1;
figure (3)
subplot(7,1,6:7)
stem(0:2*(N-1),conv(Lo_D,Lo_R)+conv(Hi_D,Hi_R))
xlabel('Time index n'), ylabel('t[n]')
axis([0,18,-0.3,2.2])