% Example_12_5
%
%       Created for the book:                                                             
%   Ljiljana D. Milic,
%      Multirate Filtering for Digital Signal Processing: MATLAB Applications                     
%      Information Science Reference, Hershey, New York,  2009
%
clear all, close all
N=18
[h0,h1,f0,f1]=firpr2chfb(N-1,0.4); %MATLAB function for the analysis/synthesis orthogonal bank
[H0,f]=freqz(h0,1,1024,2);
[H1,f]=freqz(h1,1,1024,2);
figure (1)
plot(f,abs(H0),f,abs(H1));
title('Two-channel bank')
xlabel('Normaliyed frequency')
axis([0,1,0,1.2])

% Analysis filters
hh0 = conv(h0,upsample(h0,2));  % Impulse response, 2nd level 
hh1 = conv(h0,upsample(h1,2));  % Impulse response, 2nd level 
hh2 = conv(h1,upsample(h0,2));  % Impulse response, 2nd level 
hh3 = conv(h1,upsample(h1,2));  % Impulse response, 2nd level 

% Analysis filters frequency responses
[HH0,f] = freqz(hh0,1,1024,2);  
[HH1,f] = freqz(hh1,1,1024,2);
[HH2,f] = freqz(hh2,1,1024,2);
[HH3,f] = freqz(hh3,1,1024,2);


figure (2)
subplot(4,1,1:3)
plot(f,20*log10(abs(HH0)),f,20*log10(abs(HH1)),'--b',f,20*log10(abs(HH2)),'-b',f,20*log10(abs(HH3)),'-.b')
ylabel('Gain, dB')
axis([0,1,-50,2])
ver= abs(HH0).^2+abs(HH1).^2+abs(HH2).^2+abs(HH3).^2; % Verification of the power-complementary property
figure (2)
subplot(4,1,4)
plot(f,ver), xlabel('Normalized frequency \omega/\pi'),ylabel('|T(e^j^\omega)|')
% title('Amplitude distortion')
axis([0,1,0.9,1.1])

